Package org.apache.storm.trident

## Class TridentTopology

- java.lang.Object
- - org.apache.storm.trident.TridentTopology

-     public class TridentTopology
      extends Object

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TridentTopology()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected Stream` | `addNode​(Node n)` |
    `protected Stream` | `addSourcedNode​(List<Stream> sources, Node newNode)` |
    `protected Stream` | `addSourcedNode​(Stream source, Node newNode)` |
    `protected TridentState` | `addSourcedStateNode​(List<Stream> sources, Node newNode)` |
    `protected TridentState` | `addSourcedStateNode​(Stream source, Node newNode)` |
    `StormTopology` | `build()` |
    `protected String` | `getUniqueStateId()` |
    `protected String` | `getUniqueStreamId()` |
    `protected String` | `getUniqueWindowId()` |
    `Stream` | `join​(List<Stream> streams, List<Fields> joinFields, Fields outFields)` |
    `Stream` | `join​(List<Stream> streams, List<Fields> joinFields, Fields outFields, List<JoinType> mixed)` |
    `Stream` | `join​(List<Stream> streams, List<Fields> joinFields, Fields outFields, List<JoinType> mixed, JoinOutFieldsMode mode)` |
    `Stream` | `join​(List<Stream> streams, List<Fields> joinFields, Fields outFields, JoinOutFieldsMode mode)` |
    `Stream` | `join​(List<Stream> streams, List<Fields> joinFields, Fields outFields, JoinType type)` |
    `Stream` | `join​(List<Stream> streams, List<Fields> joinFields, Fields outFields, JoinType type, JoinOutFieldsMode mode)` |
    `Stream` | `join​(Stream s1, Fields joinFields1, Stream s2, Fields joinFields2, Fields outFields)` |
    `Stream` | `join​(Stream s1, Fields joinFields1, Stream s2, Fields joinFields2, Fields outFields, List<JoinType> mixed)` |
    `Stream` | `join​(Stream s1, Fields joinFields1, Stream s2, Fields joinFields2, Fields outFields, List<JoinType> mixed, JoinOutFieldsMode mode)` |
    `Stream` | `join​(Stream s1, Fields joinFields1, Stream s2, Fields joinFields2, Fields outFields, JoinOutFieldsMode mode)` |
    `Stream` | `join​(Stream s1, Fields joinFields1, Stream s2, Fields joinFields2, Fields outFields, JoinType type)` |
    `Stream` | `join​(Stream s1, Fields joinFields1, Stream s2, Fields joinFields2, Fields outFields, JoinType type, JoinOutFieldsMode mode)` |
    `Stream` | `merge​(List<Stream> streams)` |
    `Stream` | `merge​(Stream... streams)` |
    `Stream` | `merge​(Fields outputFields, List<Stream> streams)` |
    `Stream` | `merge​(Fields outputFields, Stream... streams)` |
    `Stream` | `multiReduce​(List<GroupedStream> streams, GroupedMultiReducer function, Fields outputFields)` |
    `Stream` | `multiReduce​(List<Stream> streams, MultiReducer function, Fields outputFields)` |
    `Stream` | `multiReduce​(List<Fields> inputFields, List<GroupedStream> groupedStreams, GroupedMultiReducer function, Fields outputFields)` |
    `Stream` | `multiReduce​(List<Fields> inputFields, List<Stream> streams, MultiReducer function, Fields outputFields)` |
    `Stream` | `multiReduce​(GroupedStream s1, GroupedStream s2, GroupedMultiReducer function, Fields outputFields)` |
    `Stream` | `multiReduce​(Stream s1, Stream s2, MultiReducer function, Fields outputFields)` |
    `Stream` | `multiReduce​(Fields inputFields1, GroupedStream s1, Fields inputFields2, GroupedStream s2, GroupedMultiReducer function, Fields outputFields)` |
    `Stream` | `multiReduce​(Fields inputFields1, Stream s1, Fields inputFields2, Stream s2, MultiReducer function, Fields outputFields)` |
    `Stream` | `newDRPCStream​(String function)` |
    `Stream` | `newDRPCStream​(String function, ILocalDRPC server)` |
    `TridentState` | `newStaticState​(StateFactory factory)` |
    `TridentState` | `newStaticState​(StateSpec spec)` |
    `Stream` | `newStream​(String txId, IRichSpout spout)` |
    `Stream` | `newStream​(String txId, IBatchSpout spout)` |
    `Stream` | `newStream​(String txId, IOpaquePartitionedTridentSpout spout)` |
    `Stream` | `newStream​(String txId, IPartitionedTridentSpout spout)` |
    `Stream` | `newStream​(String txId, ITridentDataSource dataSource)` |
    `Stream` | `newStream​(String txId, ITridentSpout spout)` |
    `protected void` | `registerNode​(Node n)` |
    `protected void` | `registerSourcedNode​(List<Stream> sources, Node newNode)` |
    `TridentTopology` | `setMasterCoordResources​(DefaultResourceDeclarer resources)` |
    `TridentTopology` | `setResourceDefaults​(DefaultResourceDeclarer defaults)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TridentTopology

          public TridentTopology()

  - ### Method Detail

    - #### newStream

          public Stream newStream​(String txId,
                                  IRichSpout spout)

    - #### newStream

          public Stream newStream​(String txId,
                                  IBatchSpout spout)

    - #### newStream

          public Stream newStream​(String txId,
                                  ITridentSpout spout)

    - #### newStream

          public Stream newStream​(String txId,
                                  IPartitionedTridentSpout spout)

    - #### newStream

          public Stream newStream​(String txId,
                                  IOpaquePartitionedTridentSpout spout)

    - #### newStream

          public Stream newStream​(String txId,
                                  ITridentDataSource dataSource)

    - #### newDRPCStream

          public Stream newDRPCStream​(String function)

    - #### newDRPCStream

          public Stream newDRPCStream​(String function,
                                      ILocalDRPC server)

    - #### newStaticState

          public TridentState newStaticState​(StateFactory factory)

    - #### newStaticState

          public TridentState newStaticState​(StateSpec spec)

    - #### multiReduce

          public Stream multiReduce​(Stream s1,
                                    Stream s2,
                                    MultiReducer function,
                                    Fields outputFields)

    - #### multiReduce

          public Stream multiReduce​(Fields inputFields1,
                                    Stream s1,
                                    Fields inputFields2,
                                    Stream s2,
                                    MultiReducer function,
                                    Fields outputFields)

    - #### multiReduce

          public Stream multiReduce​(GroupedStream s1,
                                    GroupedStream s2,
                                    GroupedMultiReducer function,
                                    Fields outputFields)

    - #### multiReduce

          public Stream multiReduce​(Fields inputFields1,
                                    GroupedStream s1,
                                    Fields inputFields2,
                                    GroupedStream s2,
                                    GroupedMultiReducer function,
                                    Fields outputFields)

    - #### multiReduce

          public Stream multiReduce​(List<Stream> streams,
                                    MultiReducer function,
                                    Fields outputFields)

    - #### multiReduce

          public Stream multiReduce​(List<GroupedStream> streams,
                                    GroupedMultiReducer function,
                                    Fields outputFields)

    - #### multiReduce

          public Stream multiReduce​(List<Fields> inputFields,
                                    List<Stream> streams,
                                    MultiReducer function,
                                    Fields outputFields)

    - #### multiReduce

          public Stream multiReduce​(List<Fields> inputFields,
                                    List<GroupedStream> groupedStreams,
                                    GroupedMultiReducer function,
                                    Fields outputFields)

    - #### merge

          public Stream merge​(Fields outputFields,
                              Stream... streams)

    - #### merge

          public Stream merge​(Fields outputFields,
                              List<Stream> streams)

    - #### merge

          public Stream merge​(Stream... streams)

    - #### merge

          public Stream merge​(List<Stream> streams)

    - #### join

          public Stream join​(Stream s1,
                             Fields joinFields1,
                             Stream s2,
                             Fields joinFields2,
                             Fields outFields)

    - #### join

          public Stream join​(List<Stream> streams,
                             List<Fields> joinFields,
                             Fields outFields)

    - #### join

          public Stream join​(Stream s1,
                             Fields joinFields1,
                             Stream s2,
                             Fields joinFields2,
                             Fields outFields,
                             JoinType type)

    - #### join

          public Stream join​(List<Stream> streams,
                             List<Fields> joinFields,
                             Fields outFields,
                             JoinType type)

    - #### join

          public Stream join​(Stream s1,
                             Fields joinFields1,
                             Stream s2,
                             Fields joinFields2,
                             Fields outFields,
                             List<JoinType> mixed)

    - #### join

          public Stream join​(List<Stream> streams,
                             List<Fields> joinFields,
                             Fields outFields,
                             List<JoinType> mixed)

    - #### join

          public Stream join​(Stream s1,
                             Fields joinFields1,
                             Stream s2,
                             Fields joinFields2,
                             Fields outFields,
                             JoinOutFieldsMode mode)

    - #### join

          public Stream join​(List<Stream> streams,
                             List<Fields> joinFields,
                             Fields outFields,
                             JoinOutFieldsMode mode)

    - #### join

          public Stream join​(Stream s1,
                             Fields joinFields1,
                             Stream s2,
                             Fields joinFields2,
                             Fields outFields,
                             JoinType type,
                             JoinOutFieldsMode mode)

    - #### join

          public Stream join​(List<Stream> streams,
                             List<Fields> joinFields,
                             Fields outFields,
                             JoinType type,
                             JoinOutFieldsMode mode)

    - #### join

          public Stream join​(Stream s1,
                             Fields joinFields1,
                             Stream s2,
                             Fields joinFields2,
                             Fields outFields,
                             List<JoinType> mixed,
                             JoinOutFieldsMode mode)

    - #### join

          public Stream join​(List<Stream> streams,
                             List<Fields> joinFields,
                             Fields outFields,
                             List<JoinType> mixed,
                             JoinOutFieldsMode mode)

    - #### setResourceDefaults

          public TridentTopology setResourceDefaults​(DefaultResourceDeclarer defaults)

    - #### setMasterCoordResources

          public TridentTopology setMasterCoordResources​(DefaultResourceDeclarer resources)

    - #### build

          public StormTopology build()

    - #### getUniqueStreamId

          protected String getUniqueStreamId()

    - #### getUniqueStateId

          protected String getUniqueStateId()

    - #### getUniqueWindowId

          protected String getUniqueWindowId()

    - #### registerNode

          protected void registerNode​(Node n)

    - #### addNode

          protected Stream addNode​(Node n)

    - #### registerSourcedNode

          protected void registerSourcedNode​(List<Stream> sources,
                                             Node newNode)

    - #### addSourcedNode

          protected Stream addSourcedNode​(List<Stream> sources,
                                          Node newNode)

    - #### addSourcedNode

          protected Stream addSourcedNode​(Stream source,
                                          Node newNode)

    - #### addSourcedStateNode

          protected TridentState addSourcedStateNode​(List<Stream> sources,
                                                     Node newNode)

    - #### addSourcedStateNode

          protected TridentState addSourcedStateNode​(Stream source,
                                                     Node newNode)